/**
 * 
 */
package org.richfaces;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Random;

import javax.faces.context.FacesContext;

/**
 * @author Nick Belaevski
 *         mailto:nbelaevski@exadel.com
 *         created 16.11.2007
 *
 */
public class ListShuttleDemoBean {

	private Collection sourceSelection;
	private Collection targetSelection;
	
	private ListShuttleOptionItem[] source;
	
	private List target;
	
	private boolean moveControlsVisible = true;
	private boolean fastMoveControlsVisible = true;
	
	private boolean orderControlsVisible = true;
	private boolean fastOrderControlsVisible = true;

	public ListShuttleDemoBean() {
		super();
		
		source = new ListShuttleOptionItem[3];
		for (int i = 0; i < source.length; i++) {
			source[i] = new ListShuttleOptionItem("Source Item " + i, new Random().nextInt(40));
		}

		target = new ArrayList();
		for (int i = 0; i < 5; i++) {
			target.add(new ListShuttleOptionItem("Target Item " + i, new Random().nextInt(40)));
		}
	}
	
	public ListShuttleOptionItem[] getSource() {
		return source;
	}

	private static String arrayToString(Object[] objects) {
		StringBuffer result = new StringBuffer();
		if (objects == null) {
			result.append("null");
		} else {
			int iMax = objects.length - 1;
			if (iMax == -1) {
				result.append("[]");
			} else {
				result.append('[');
				for (int i = 0; i <= iMax; i++) {
					result.append(objects[i]);
					if (i != iMax) {
						result.append(", ");
					}
				}
				result.append(']');
			}
		}
		
		return result.toString();
	}
	
	public void setSource(ListShuttleOptionItem[] source) {
		System.out.print("ListShuttleDemoBean.setSource() ");
		System.out.println(arrayToString(source));
		
		this.source = source;
	}
	
	public List getTarget() {
		return target;
	}
	
	public void setTarget(List target) {
		System.out.println("ListShuttleDemoBean.setTarget() " + target);
		this.target = target;
	}
	
	public void startOver() {
		FacesContext.getCurrentInstance().getExternalContext().getSessionMap().remove("listShuttleDemoBean");
	}

	public boolean isMoveControlsVisible() {
		return moveControlsVisible;
	}

	public void setMoveControlsVisible(boolean moveControlsVisible) {
		this.moveControlsVisible = moveControlsVisible;
	}

	public boolean isFastMoveControlsVisible() {
		return fastMoveControlsVisible;
	}

	public void setFastMoveControlsVisible(boolean fastMoveControlsVisible) {
		this.fastMoveControlsVisible = fastMoveControlsVisible;
	}

	public boolean isOrderControlsVisible() {
		return orderControlsVisible;
	}

	public void setOrderControlsVisible(boolean orderControlsVisible) {
		this.orderControlsVisible = orderControlsVisible;
	}

	public boolean isFastOrderControlsVisible() {
		return fastOrderControlsVisible;
	}

	public void setFastOrderControlsVisible(boolean fastOrderControlsVisible) {
		this.fastOrderControlsVisible = fastOrderControlsVisible;
	}

	public Collection getSourceSelection() {
		return sourceSelection;
	}

	public void setSourceSelection(Collection sourceSelection) {
		System.out.println("ListShuttleDemoBean.setSourceSelection() " + sourceSelection);
		this.sourceSelection = sourceSelection;
	}

	public Collection getTargetSelection() {
		return targetSelection;
	}

	public void setTargetSelection(Collection targetSelection) {
		System.out.println("ListShuttleDemoBean.setTargetSelection() " + targetSelection);
		this.targetSelection = targetSelection;
	}
	
}
